#version 120

uniform sampler2D src_tex_unit0;
uniform sampler2D src_tex_unit1;
uniform sampler2D src_tex_unit2;

varying vec4 v_color;
varying vec2 texcoord;

void main() {
	float y = texture2D(src_tex_unit0, texcoord).r;
	float u = texture2D(src_tex_unit1, texcoord).r - 0.5;
	float v = texture2D(src_tex_unit2, texcoord).r - 0.5;

	y = (y - 0.5) * 1.1 + 0.5;

	float r = y + 1.402 * v;
	float g = y - 0.344 * u - 0.714 * v;
	float b = y + 1.772 * u;

	gl_FragColor = vec4(r * v_color.r, g * v_color.g, b * v_color.b, v_color.a);
}
